#ifndef DECODER_H
#define DECODER_H

#define MAX_FILENAME 256

#include "frame.h"
#include "videoProperties.h"

class Decoder
{
public:
  Decoder(char* filename);
  virtual ~Decoder();

  char* GetFilename();
  virtual VideoProperties* GetVideoProperties()=0;
  virtual int GetFrame(frame* &vidframe)=0;
  virtual int GetAudio(short* buffer, int samples, int channel)=0;
  // virtual double GetPercentageDone()=0;
  virtual int EndOfVideo()=0;
  virtual long FrameNumber()=0;
  
protected:
  char video_filename[MAX_FILENAME];
  VideoProperties *vidprops;
};

#endif //#ifndef DECODER_H
