#include <cstring>
#include <iostream>
#include <cstdio>
#include <new>
#include "frame.h"

using namespace std;

frame::frame(double time, unsigned char *img, int width, int height, 
	     int frameSize, int format, int a_iFrameNo)
{
  m_dTimestamp = time;
 
  try{
    m_pcImage = new unsigned char[frameSize];
  }catch (bad_alloc xa){
    cerr << "*** Allocation failure ***" << endl;
  }
  if (m_pcImage == NULL)
    cerr << "*** Allocation failure ***" << endl;

  memcpy(m_pcImage, img, frameSize);

  m_iWidth = width;
  m_iHeight = height;

  m_iFrameNo = a_iFrameNo;
  m_iFrameSize = frameSize;
  
  isTransEnd = 0;
  transType = NONE;

  isKeyFrame = 0;
}

frame::frame(double time, char *ybuffer, char *ubuffer, char *vbuffer, 
	     int width, int height, int frameSize, int format, int a_iFrameNo)
{
  m_dTimestamp = time;
 
  try{
    m_pcImage = new unsigned char[frameSize];
  }catch (bad_alloc xa){
    cerr << "*** Allocation failure ***" << endl;
  }
  if (m_pcImage == NULL)
    cerr << "*** Allocation failure ***" << endl;

  memcpy(m_pcImage, ybuffer, width * height);
  memcpy(m_pcImage+(width*height), ubuffer, (width*height/4));
  memcpy(m_pcImage+(width*height)+(width*height/4), vbuffer, (width*height/4));

  m_iWidth = width;
  m_iHeight = height;

  m_iFrameNo = a_iFrameNo;
  m_iFrameSize = frameSize;
  
  isTransStart = 0;
  isTransEnd = 0;

  isKeyFrame = 0;
  transType = NONE;
}

//Copy constructor
frame::frame(const frame &fr)
{
  m_iFrameNo = fr.m_iFrameNo;
  m_dTimestamp = fr.m_dTimestamp;
  m_iWidth = fr.m_iWidth;
  m_iHeight = fr.m_iHeight;
  m_iFrameSize = fr.m_iFrameSize;
  isTransStart = fr.isTransStart;
  isTransEnd = fr.isTransEnd;
  transStartFr = fr.transStartFr;
  transType = fr.transType;
  isKeyFrame = fr.isKeyFrame;

  m_pcImage = new unsigned char[m_iFrameSize];
  
  memcpy(m_pcImage, fr.m_pcImage, m_iFrameSize);
}

frame::~frame()
{
  delete []m_pcImage;
}

void frame::DeleteImage()
{
  delete []m_pcImage;
}





