#ifndef FRAME_H
#define FRAME_H

enum transition {NONE, CUT, GRADUAL};

#include <iostream>

class frame
{
 public:
  frame(double time, unsigned char *img, int width, int height, int frameSize,
	int format, int a_iFrameNo);
  frame(double time, char *ybuffer, char *ubuffer, char *vbuffer, 
	int width, int height, int frameSize, int format, int a_iFrameNo);
  //copy constructor
  frame(const frame &fr);
  ~frame();

  void DeleteImage();
 
  //Member variables
  int m_iFrameNo; 
  unsigned char *m_pcImage; //The pixel data
  double m_dTimestamp; //In milliseconds (?seconds in MPEG)
  int m_iWidth; //Dimensions in pixels 
  int m_iHeight;
  int m_iFrameSize;  
  int isTransStart; //nonzero if this frame is the POTENTIAL
                    //  start of a transition
  int isTransEnd; //nonzero if this frame is the end of a transition
  int transStartFr; //if isTransEnd, start frame of transition
  transition transType; //if isTransEnd, cut or gradual
  int isKeyFrame;

  frame& operator=(frame& f) 
    { 
      m_iFrameNo   = f.m_iFrameNo; 
      m_dTimestamp = f.m_dTimestamp; 
      m_iWidth     = f.m_iWidth; 
      m_iHeight    = f.m_iHeight;
      m_iFrameSize = f.m_iFrameSize;  
      isTransStart = f.isTransStart; 
      
      isTransEnd   = f.isTransEnd; 
      transStartFr = f.transStartFr; 
      transType    = f.transType; 
      isKeyFrame   = f.isKeyFrame;

      m_pcImage = new unsigned char[m_iFrameSize];  
      memcpy(m_pcImage, f.m_pcImage, m_iFrameSize);

      return f; 
    }

 private:
  //Member functions

  //Member variables
};



#endif //#ifndef FRAME_H
