#ifndef MPEGDECODER_H
#define MPEGDECODER_H

#include <libmpeg3.h> 
#include "decoder.h"

class MPEG_Decoder : public Decoder
{
public:
  MPEG_Decoder(char* filename);
  ~MPEG_Decoder();

  VideoProperties* GetVideoProperties();
  int GetFrame(frame* &vidframe);
  int GetAudio(short* buffer, int samples, int channel);
  double GetPercentageDone();
  int EndOfVideo();
  long FrameNumber();

private:
  mpeg3_t* mpegfile;
  VideoProperties *vidprops;
  frame* currframe;
  int frameno;
};

#endif //#ifndef MPEGDECODER_H
